unit EU_SYNCH;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Menus, StdCtrls, ComCtrls, ltrapi, ltrapidefine, ltrapitypes;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    ComboBox1: TComboBox;
    StatusBar1: TStatusBar;
    LOG: TListBox;
    EU_PAN: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Button2: TButton;
    Button4: TButton;
    Button5: TButton;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    CheckBox1: TCheckBox;
    ComboBox6: TComboBox;
    ComboBox7: TComboBox;
    ComboBox8: TComboBox;
    ComboBox9: TComboBox;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Button3: TButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  LTR:TLTR;
  CRATES:array[0..16,0..16]of char;
  TotalCrates:integer;
  LTR_ON_LINE:boolean;
  SelectedCrate:integer;
  LTR_INF:TCRATE_INFO;
  IS_LTR_EU:boolean;
implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var i,j:integer;
    BUF:array[0..255]of char;
begin
        LTR_Init(@LTR);
        LTR_Open(@LTR);
        LTR_GetCrates(@LTR,@CRATES[0][0]);
        ComboBox1.Items.Clear();
        ComboBox1.Text:=' ';
        TotalCrates:=0;
        for i:=0 to 15 do
        if CRATES[i]<>'' then
        begin
                for j:=0 to 15 do BUF[j]:=CRATES[i][j];
                ComboBox1.Items.Add(BUF);
                LOG.Items.Add(' : '+BUF);
                TotalCrates:=TotalCrates+1;
        end;
        LOG.Items.Add(' : '+IntToStr(TotalCrates));

        ComboBox1.ItemIndex:=0;
        LTR_Close(@LTR);
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var res,j:integer;
    BUF:array[0..255]of char;
begin
        if TotalCrates>0 then
        begin
                if LTR_ON_LINE=true then
                begin
                        for j:=0 to 15 do BUF[j]:=LTR.csn[j];
                        LOG.Items.Add('    '+BUF);
                        LTR_Close(@LTR);
                        LTR_ON_LINE:=false;
                end;
                SelectedCrate:=ComboBox1.ItemIndex;
                LTR_Init(@LTR);
                for j:=0 to 15 do LTR.csn[j]:=CRATES[SelectedCrate][j];
                res:=LTR_Open(@LTR);
                if res<>LTR_OK then
                begin
                       LOG.Items.Add(' ,  '+IntToStr(res));
                       exit;
                end;
                for j:=0 to 15 do BUF[j]:=LTR.csn[j];
                LOG.Items.Add(' '+BUF+' ');
                LTR_ON_LINE:=true;
                LTR_GetCrateInfo(@LTR,@LTR_INF);
                LOG.Items.Add('  :');
                case (LTR_INF.CrateType)of
                        CRATE_TYPE_LTR010: begin; BUF:='LTR010';IS_LTR_EU:=false; end;
                        CRATE_TYPE_LTR021: begin; BUF:='LTR021';IS_LTR_EU:=false; end;
                        CRATE_TYPE_LTR030: begin; BUF:='LTR030';IS_LTR_EU:=true;  end;
                        CRATE_TYPE_LTR031: begin; BUF:='LTR031';IS_LTR_EU:=true;  end;
                end;
                LOG.Items.Add(' : '+BUF);


                case (LTR_INF.CrateInterface)of
                        CRATE_IFACE_USB:    BUF:='USB';
                        CRATE_IFACE_TCPIP:  BUF:='TCP/IP';
                end;
                LOG.Items.Add(' :'+BUF);
                EU_PAN.Visible:=IS_LTR_EU;
        end;

end;

procedure TForm1.FormCreate(Sender: TObject);
var j:integer;
    BUF:array[0..255]of char;
begin
                if LTR_ON_LINE=true then
                begin
                        for j:=0 to 15 do BUF[j]:=LTR.csn[j];
                        LOG.Items.Add('    '+BUF);
                        LTR_Close(@LTR);
                        LTR_ON_LINE:=false;
                end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var res:integer;
    LTR_CNF:TLTR_CONFIG;
begin
       LTR_CNF.userio[0]:=ComboBox2.ItemIndex;
       LTR_CNF.userio[1]:=ComboBox3.ItemIndex;
       LTR_CNF.userio[2]:=ComboBox4.ItemIndex;
       LTR_CNF.userio[3]:=ComboBox5.ItemIndex;
       LTR_CNF.digout[0]:=ComboBox6.ItemIndex;
       LTR_CNF.digout[1]:=ComboBox7.ItemIndex;
       LTR_CNF.digout_en:=ord(CheckBox1.Checked);
       res:=LTR_Config(@LTR,@LTR_CNF);
       if res<>LTR_OK then
       begin
                LOG.Items.Add('  , : '+IntToStr(res));
       end;
       LOG.Items.Add(' !!');
end;

procedure TForm1.Button2Click(Sender: TObject);
var res:integer;
begin
        res:=LTR_StartSecondMark(@LTR,en_LTR_MarkMode(ComboBox8.ItemIndex));
        if(res<>LTR_OK)then
        begin
                LOG.Items.Add('  !, : '+IntToStr(res));
        end
        else
        begin
                LOG.Items.Add(' !!!!');
        end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var res:integer;
begin
        res:=LTR_StopSecondMark(@LTR);
        if(res<>LTR_OK)then
        begin
                LOG.Items.Add('   !, : '+IntToStr(res));
        end
        else
        begin
                LOG.Items.Add(' !!!!');
        end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var res:integer;
begin
        res:=LTR_MakeStartMark(@LTR,en_LTR_MarkMode(ComboBox9.ItemIndex));
        if(res<>LTR_OK)then
        begin
                LOG.Items.Add('  !, : '+IntToStr(res));
        end;
        LOG.Items.Add('!!!');
end;

procedure TForm1.N1Click(Sender: TObject);
begin
        LOG.Items.Clear();
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
    DATA:DWORD;
    LTR_CNF:TLTR_CONFIG;
begin
        if(LTR_ON_LINE=true)then
        begin
                DATA:=LTR.tmark;
                Edit1.Text:=IntToStr(DATA and $FFFF);
                Edit2.Text:=IntToStr(DATA shr 16);
        end;

end;

end.


